/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _OPENGL_OPTIONS_H
#define _OPENGL_OPTIONS_H

#include <core/core.h>

class OpenglOptions : public CompOption::Class {
    public:
        enum Options {
            TextureFilter,
            Lighting,
            SyncToVblank,
            TextureCompression,
            OptionNum
        };

        enum TextureFilter {
            TextureFilterFast = 0,
            TextureFilterGood = 1,
            TextureFilterBest = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        OpenglOptions ();
        virtual ~OpenglOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        int optionGetTextureFilter ();
        void optionSetTextureFilterNotify (ChangeNotify notify);

        bool optionGetLighting ();
        void optionSetLightingNotify (ChangeNotify notify);

        bool optionGetSyncToVblank ();
        void optionSetSyncToVblankNotify (ChangeNotify notify);

        bool optionGetTextureCompression ();
        void optionSetTextureCompressionNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline int
OpenglOptions::optionGetTextureFilter ()
{
    return mOptions[OpenglOptions::TextureFilter].value ().i ();
}

inline void
OpenglOptions::optionSetTextureFilterNotify (OpenglOptions::ChangeNotify notify)
{
    mNotify[OpenglOptions::TextureFilter] = notify;
}

inline bool
OpenglOptions::optionGetLighting ()
{
    return mOptions[OpenglOptions::Lighting].value ().b ();
}

inline void
OpenglOptions::optionSetLightingNotify (OpenglOptions::ChangeNotify notify)
{
    mNotify[OpenglOptions::Lighting] = notify;
}

inline bool
OpenglOptions::optionGetSyncToVblank ()
{
    return mOptions[OpenglOptions::SyncToVblank].value ().b ();
}

inline void
OpenglOptions::optionSetSyncToVblankNotify (OpenglOptions::ChangeNotify notify)
{
    mNotify[OpenglOptions::SyncToVblank] = notify;
}

inline bool
OpenglOptions::optionGetTextureCompression ()
{
    return mOptions[OpenglOptions::TextureCompression].value ().b ();
}

inline void
OpenglOptions::optionSetTextureCompressionNotify (OpenglOptions::ChangeNotify notify)
{
    mNotify[OpenglOptions::TextureCompression] = notify;
}



#endif
