/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ZOOM_OPTIONS_H
#define _ZOOM_OPTIONS_H

#include <core/core.h>

class ZoomOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateButton,
            ZoomInButton,
            ZoomOutButton,
            ZoomPanButton,
            Speed,
            Timestep,
            ZoomFactor,
            FilterLinear,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ZoomOptions ();
        virtual ~ZoomOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomInButton ();
        void optionSetZoomInButtonInitiate (CompAction::CallBack init);
        void optionSetZoomInButtonTerminate (CompAction::CallBack term);
        void optionSetZoomInButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomOutButton ();
        void optionSetZoomOutButtonInitiate (CompAction::CallBack init);
        void optionSetZoomOutButtonTerminate (CompAction::CallBack term);
        void optionSetZoomOutButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomPanButton ();
        void optionSetZoomPanButtonInitiate (CompAction::CallBack init);
        void optionSetZoomPanButtonTerminate (CompAction::CallBack term);
        void optionSetZoomPanButtonNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        float optionGetZoomFactor ();
        void optionSetZoomFactorNotify (ChangeNotify notify);

        bool optionGetFilterLinear ();
        void optionSetFilterLinearNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
ZoomOptions::optionGetInitiateButton ()
{
    return mOptions[ZoomOptions::InitiateButton].value ().action ();
}

inline void
ZoomOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[ZoomOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
ZoomOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[ZoomOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
ZoomOptions::optionSetInitiateButtonNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::InitiateButton] = notify;
}

inline CompAction &
ZoomOptions::optionGetZoomInButton ()
{
    return mOptions[ZoomOptions::ZoomInButton].value ().action ();
}

inline void
ZoomOptions::optionSetZoomInButtonInitiate (CompAction::CallBack init)
{
    mOptions[ZoomOptions::ZoomInButton].value ().action ().setInitiate (init);
}

inline void
ZoomOptions::optionSetZoomInButtonTerminate (CompAction::CallBack term)
{
    mOptions[ZoomOptions::ZoomInButton].value ().action ().setTerminate (term);
}

inline void
ZoomOptions::optionSetZoomInButtonNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::ZoomInButton] = notify;
}

inline CompAction &
ZoomOptions::optionGetZoomOutButton ()
{
    return mOptions[ZoomOptions::ZoomOutButton].value ().action ();
}

inline void
ZoomOptions::optionSetZoomOutButtonInitiate (CompAction::CallBack init)
{
    mOptions[ZoomOptions::ZoomOutButton].value ().action ().setInitiate (init);
}

inline void
ZoomOptions::optionSetZoomOutButtonTerminate (CompAction::CallBack term)
{
    mOptions[ZoomOptions::ZoomOutButton].value ().action ().setTerminate (term);
}

inline void
ZoomOptions::optionSetZoomOutButtonNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::ZoomOutButton] = notify;
}

inline CompAction &
ZoomOptions::optionGetZoomPanButton ()
{
    return mOptions[ZoomOptions::ZoomPanButton].value ().action ();
}

inline void
ZoomOptions::optionSetZoomPanButtonInitiate (CompAction::CallBack init)
{
    mOptions[ZoomOptions::ZoomPanButton].value ().action ().setInitiate (init);
}

inline void
ZoomOptions::optionSetZoomPanButtonTerminate (CompAction::CallBack term)
{
    mOptions[ZoomOptions::ZoomPanButton].value ().action ().setTerminate (term);
}

inline void
ZoomOptions::optionSetZoomPanButtonNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::ZoomPanButton] = notify;
}

inline float
ZoomOptions::optionGetSpeed ()
{
    return mOptions[ZoomOptions::Speed].value ().f ();
}

inline void
ZoomOptions::optionSetSpeedNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::Speed] = notify;
}

inline float
ZoomOptions::optionGetTimestep ()
{
    return mOptions[ZoomOptions::Timestep].value ().f ();
}

inline void
ZoomOptions::optionSetTimestepNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::Timestep] = notify;
}

inline float
ZoomOptions::optionGetZoomFactor ()
{
    return mOptions[ZoomOptions::ZoomFactor].value ().f ();
}

inline void
ZoomOptions::optionSetZoomFactorNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::ZoomFactor] = notify;
}

inline bool
ZoomOptions::optionGetFilterLinear ()
{
    return mOptions[ZoomOptions::FilterLinear].value ().b ();
}

inline void
ZoomOptions::optionSetFilterLinearNotify (ZoomOptions::ChangeNotify notify)
{
    mNotify[ZoomOptions::FilterLinear] = notify;
}



#endif
